from Prof import Prof
from PosGrad import PosGrad
from Data import Data

class ProfPos(Prof, PosGrad):
    def __init__(self, profpos = 0):
        if type(profpos) is profpos:
            self.nome = profpos.nome
            self.idade = profpos.idade
            self.sexo = profpos.sexo
            self.salario = profpos.salario
            self.matrFun = profpos.matrEst
            self.entrFun.copia(profpos.entrEst)
            self.regime = profpos.regime
            self.cr = profpos.cr
            self.matrEst = profpos.matrEst
            self.entrEst.copia(profpos.entrEst)
            self.cursoForm = profpos.cursoForm
        else:
            self.nome = ""
            self.idade = 0
            self.sexo = ''
            self.salario = 0.0
            self.matrFun = 0
            self.entrFun = Data("00/00/0000")
            self.regime = ""
            self.cr = 0.0
            self.matrEst = 0
            self.entrEst = Data("00/00/0000")
            self.cursoForm = ""

    def retornaMaiorMat(self):
            if self.matrEst >= self.matrFun:
                return self.matrEst
            else:
                return self.matrFun

    def leitura(self, linhas, numPrimLinha):
        self.nome = linhas[numPrimLinha]
        self.idade = int(linhas[(numPrimLinha+1)])
        self.sexo = linhas[(numPrimLinha+2)]
        self.matrFun = int(linhas[(numPrimLinha+3)])
        self.entrFun = Data(linhas[(numPrimLinha+4)])
        self.salario = float(linhas[(numPrimLinha+5)])
        self.regime = linhas[(numPrimLinha+6)]
        self.matrEst = int(linhas[(numPrimLinha+7)])
        self.entrEst = Data(linhas[(numPrimLinha+8)])
        self.curso = linhas[(numPrimLinha+9)]
        self.cr = float(linhas[(numPrimLinha+10)])
        self.cursoForm = linhas[(numPrimLinha+11)]
        return (numPrimLinha+12)

    def apresenta(self):
        print("\n Nome: " + self.nome)
        print(" Idade: " + str(self.idade))
        print(" Sexo: " + self.sexo)
        print(" Salario: " + str(self.salario))
        print(" Matricula de Funcionario: " + str(self.matrFun) )
        print(" Data de Entrada como Funcionario: " + self.entrFun.retornaData())
        print(" Regime: " + self.regime )
        print(" Coeficiente de Rendimento: " + str(self.cr))
        print(" Matricula de Estudante: " + str(self.matrEst) )
        print(" Data de Entrada como Estudante: " + self.entrEst.retornaData())
        print(" Curso de Formacao: "+ str(self.cursoForm) )