from MembroUni import comparaMU
from PosGrad import PosGrad, comparaPos
from ServGrad import ServGrad, Serv, Grad
from Prof import Prof, comparaProf
from ProfGrad import ProfGrad
from ServPos import ServPos
from ProfPos import ProfPos
from Estudante import Estudante, comparaEst
from Funcionario import Funcionario, comparaFun

def retornaNovaCat(categoria):
    if categoria == "prof":
        return Prof()
    elif categoria == "serv":
        return Serv()
    elif categoria == "grad":
        return Grad()
    elif categoria == "pos":
        return PosGrad()
    elif categoria == "serv_grad":
        return ServGrad()
    elif categoria == "prof_grad":
        return ProfGrad()
    elif categoria == "prof_pos":
        return ProfPos()
    elif categoria == "serv_pos":
        return ServPos()

#Ler um arquivo
def lerArq(nomearq):
    arq = open(nomearq)
    linhas =[]
    for linha in arq:
        linhas.append(linha.rstrip("\n"))
    arq.close()
    return linhas


def lerLista(nomearq):
    linhas = lerArq(nomearq)
    tam = len(linhas)
    i = 0
    lis = []
    while i < tam:
        x = retornaNovaCat(linhas[i])
        lis.append(x)
        i = 1 + x.leitura(linhas,(i+1))
    return lis

def zeraMat(lis, matr):
    for x in lis:
        if isinstance(x,Estudante):
            if matr == x.retornaMatrEst():
                x.atualizaMatrEst(0)
                break
        if isinstance(x,Funcionario):
            if matr == x.retornaMatrFun():
                x.atualizaMatrFun(0)
                break

def atualizaLista(lis, nomearq):
    linhas = lerArq(nomearq)
    tam = len(linhas)
    i = 0
    while i < tam:
        if linhas[i] == "i":
            i += 1
            novo = retornaNovaCat(linhas[i])
            i = 1 + novo.leitura(linhas,(i+1))
            lis.append(novo)
        elif linhas[i] == "e":
            zeraMat(lis,int(linhas[i+1]))
            i += 3
        elif linhas[i] == "a":
            i += 1
            novo = retornaNovaCat(linhas[i])
            i = 1 + novo.leitura(linhas,(i+1))
            for x in lis:
                if isinstance(novo,Funcionario)and isinstance(x,Funcionario):
                    if novo.retornaMatrFun() == x.retornaMatrFun():
                        lis.remove(x)
                elif isinstance(novo,Estudante)and isinstance(x,Estudante):
                    if novo.retornaMatrEst() == x.retornaMatrEst():
                        lis.remove(x)
            lis.append(novo)
    return lis

class list2(list):
    def particiona(self, esq, dir, compara):
        pivo = self[(esq+dir)//2]
        i = esq
        j = dir
        while i <= j:
            while compara(pivo,self[i]) and i < dir: i += 1
            while compara(self[j],pivo) and j > esq: j -= 1
            if i <= j:
                self[i], self[j] = self[j], self[i]
                i += 1
                j -= 1
        return i

    def quicksort(self, esq, dir, compara):
        if esq < dir:
            i = self.particiona(esq,dir,compara)
            self.quicksort(esq,i-1,compara)
            self.quicksort(i,dir, compara)


lis = lerLista("mestre.txt")
lis = atualizaLista(lis,"atual.txt")

lisMU = list2()
lisProf = list2()
lisPos = list2()
lisEst = list2()
lisFun = list2()

for m in lis:
    if isinstance(m,Prof):
        if m.retornaRegime() == "40" and m.matrFun != 0:
            lisProf.append(m)
    if isinstance(m,PosGrad):
        if m.matrEst != 0:
            lisPos.append(m)
    if isinstance(m,Estudante):
        if m.matrEst != 0:
            lisEst.append(m)
    if isinstance(m,Funcionario):
        if m.matrFun != 0:
            lisFun.append(m)
    if isinstance(m,Funcionario):
        if m.matrFun != 0:
            if isinstance(m,Estudante):
                if m.matrEst != 0:
                    lisMU.append(m)
            else:
                lisMU.append(m)
    elif isinstance(m,Estudante):
        if m.matrEst != 0:
            if isinstance(m,Funcionario):
                if m.matrFun != 0:
                    lisMU.append(m)
            else:
                lisMU.append(m)




lisMU.quicksort(0,len(lisMU)-1,comparaMU)
lisProf.quicksort(0,len(lisProf)-1,comparaProf)
lisPos.quicksort(0,len(lisPos)-1,comparaPos)
lisEst.quicksort(0,len(lisEst)-1,comparaEst)
lisFun.quicksort(0,len(lisFun)-1,comparaFun)


tr = ' -------------- '
nline = '\n' 

print(nline + tr + 'Lista de professores' + tr + nline);
for m in lisProf:
    m.apresenta()

print(nline + tr + 'Lista de estudantes de pos-graduacao' + tr + nline);
for m in lisPos:
    m.apresenta()

print(nline + tr + 'Lista de estudantes' + tr + nline);
for m in lisEst:
    m.apresenta()

print(nline + tr + 'Lista de funcionarios' + tr + nline);
for m in lisFun:
    m.apresenta()
